View Issue Details

IDProjectCategoryView StatusLast Update
0001392Composr[All Projects] Generalpublic2016-12-08 17:21
ReporterLhasadreamsAssigned ToChris Graham 
Severityfeature 
Status closedResolutionfixed 
Product Version 
Fixed in Version 
Summary0001392: Adding images from Photobucket, Flickr and Perhaps Facebook
DescriptionHi,
The rise of Facebook is challenging traditional forum usage.
One area that our site suffers from is how easy it is to add images to threads. Yes you can upload to a hosting site and copy in the URL. But compare this to the slickness of doing this with Facebook.

What I am wondering is how difficult would it be to add a button to a post that allows you to upload an image to either Photobucket or Flickr or another photo storage application and insert the image in to the thread - all with the single press of a button. Either prompt of credentials or make them a setup stage.

Would Composr cost this up please.

Really happy to listen to suggestions and the viability of this.

Just trying to make the experience slicker. What we are seeing is people post images to Facebook and less on the main forum - I want to reverse this.

Cheers
Ade
Additional InformationChris says...

Other interesting services for future consideration:
Dropbox
Google Drive
Skydrive
ImageShack
imgur
Instagram

UI method to deauthorise an account, so you can authorise a different one.
TagsType: External social media integration
Attach Tags
Time estimation (hours)
Sponsorship open

Relationships

parent of 0000980 closedChris Graham Amazon S3 support 
related to 0002962 non-assigned Allow backup to use cdn_transfer mechanism 
related to 0003147 non-assigned Review of cloud filesystem support 

Activities

Chris Graham

2013-09-08 21:07

administrator   ~0001700

I will get back to you on this. You may want to read 0001310, which is currently under implementation.

This sounds more like syndication outward, which I agree is interesting :).

Lhasadreams

2013-09-08 21:32

reporter   ~0001701

That is very interesting as well :-) I like the idea of there being a standard protocol like oEmbed.

While making use of all that lovely free storage out there !!

For me the user experience will be key here.

As a forum user I want to be able to press a button that allows an image stored on my device to be transferred to my chosen photo storage provider and a link to it placed in my forum thread.

Devices will mainly be smart phones and tablets.
Photo storage will be Photobucket, Flickr + probably others.

Look forward to your reply

Chris Graham

2013-09-09 12:24

administrator   ~0001707

Could you confirm the use case(s) for me please...

Is it that people want to keep their photos all in one place, so they post primarily to their main photo store/album and don't bother posting it on the site?
So, you want to let them achieve both objectives at once, via your site.


When you add an attachment, it would popup the options dialogue for that attachment as normal. But, if it was an image, there'd be additional checkboxes to syndicate to various targets. The checkboxes would be greyed if the service had not yet been set up, with a 'setup' button next to it.

It seems worthwhile doing for galleries too. So, also these options on the gallery form.

Lhasadreams

2013-09-09 20:21

reporter   ~0001713

Hi Chris,

We do not allow attachments at all because we would soon run out of disk space to store them. So the only way that people can put an image up is by linking to one they have stored elsewhere. We recommend Photobucket and Flickr.

The use case that you describe is spot on.

Cheers
Ade

Chris Graham

2013-09-11 17:53

administrator   ~0001722

Hi,

The quote would be:
6 hours + 5 hour per API.
So for 3 APIs... (6+5*3)*33=£693 GBP.

The 6 hours would be to modify the attachment system and interface to be able to include the setup and transfer buttons for external hosting services, sync up with the uploader properly, and be able to include remote URL references in as the attachment URLs.

Then for each API we would need to implement oAuth against it and code up against its API.

Lhasadreams

2013-09-11 20:06

reporter   ~0001723

Hi Chris,

Does the cost scale down if we just went for 1 API to begin with:

(6+5)*33=£363

I am thinking Photobucket first as it is the most common one in use today.

Cheers
Ade

Lhasadreams

2013-09-11 20:57

reporter   ~0001724

I am in the process of getting the spend authorised.

One point the source of the image to syndicate must work from phones, tablets and computers - is that included in your design ?

Cheers
Ade

Chris Graham

2013-09-11 21:02

administrator   ~0001725

Yes, I designed the cost equation to scale according to what services you wanted.

It would work via the user oAuth'ing their photo service such that the server can then copy the uploaded file across to the user's account on the photo service via its API (server to server). That is browser-agnostic. Essentially this just extends the existing attachment system (and gallery system to - I didn't include in the quote, but I may do it).

Note mostly for myself:
Regarding your specific situation, the system will need to be aware that you have to sync to Photobucket and that the file should not kept on your server (given the attachment quota's are zero).

Lhasadreams

2013-09-12 07:48

reporter   ~0001726

Hi Chris,
Payment authorised and credits loaded.
Please can you implement.
Cheers
Ade

Chris Graham

2013-09-15 14:50

administrator   ~0001737

Hi,

I have this implemented, but not yet tested. I am waiting on Photobucket to provide an API key, as they took their developer site down early in the year (without announcement - prior to a new site, which seems to have been very delayed) and are just providing keys by request.

Lhasadreams

2013-09-15 19:47

reporter   ~0001739

Hi Chris,

Ooooh that is good news !

Hopefully they will sort it out asap.

Cheers
Ade

Chris Graham

2013-09-17 00:00

administrator   ~0001740

It works (photobucket) :).

I will deploy for you soon. I will leave this issue open, as there are many other possible services to integrate.

Chris Graham

2013-09-21 20:35

administrator   ~0001749

Hi,

This is now deployed for you Lhasadreams.

Usage should be very simple...
1) Assumption: user has a photobucket account
2) Go to post
3) See attachment options (as per Composr-standard)
4) Check the Photobucket option
5) As oAuth dialogue will open in an overlay
6) Give permission
7) Close the overlay
8) Choose file as per normal Composr / configure attachment
9) Post

Subsequently, the photobucket option should be auto-checked, as oAuth is set up for future use also.

For users with no quota, the syndication happens then the local file is removed - so the attachment references the remote. For users with a quota, the attachment will reference local, and it will have only syndicated. Users with no quota will see "required" shown by the photobucket checkbox, indicating it is necessary to pick that.

Chris Graham

2013-09-21 20:36

administrator   ~0001750

Oh, and the oAuth dialogue mentions the request key. Composr picks this up automatically, no config is needed by the user.

It's a shame we cannot auto-close the dialogue, but unfortunately Photobucket doesn't support oAuth callback URLs, which would be necessary for that.

Lhasadreams

2013-09-21 20:50

reporter   ~0001752

Thanks very much for this Chris !

I am away this weekend - Segway near Knaresborough !!

I have just tried it in my phone but I cannot see the dialogue or scroll it :-(

Any chance this can be changed ?

Cheers
Ade

Chris Graham

2013-09-22 00:48

administrator   ~0001754

Hi,

(Knaresborough is a lovely place, I miss it - I grew up in Harrogate)

I forgot to test on mobile. I just tested on iphone. Moved oAuth overlay to be a new window instead (would not fit on width as an overlay). Optimised the attachment/Comcode adding overlay a lot. Fought with layers of caching for ages... and eventually, it works for me.

This does not tally up with not seeing a dialogue at all, but I can confirm I got it to submit right through to photobucket from an image on my iPhone simulator.

Lhasadreams

2013-09-22 06:54

reporter   ~0001755

Hi Chris,
I am getting an error when I click add topic.
It appears at the top of the page.
I am on an iPhone 5 with iOS 7.

If I carry on and tick the photobucket box under upload I get the same error from them.

Lhasadreams

2013-09-22 06:54

reporter  

image.jpg (167,869 bytes)
image.jpg (167,869 bytes)

Lhasadreams

2013-09-22 07:22

reporter   ~0001756

Hi Chris,
I managed to get in on my iPad by logging into photobucket from another window. The integration then let me select my setup. We do need to change the Composr Test key though as it will look strange to users.

Once in and with the Photobucket box ticked I then clicked upload, selected my image etc and the image uploaded to photobucket but in Composr it just created a new attachment rather than URL link.

Cheers
Ade

Chris Graham

2013-09-22 10:22

administrator   ~0001757

"I am getting an error when I click add topic.
It appears at the top of the page.
I am on an iPhone 5 with iOS 7.

If I carry on and tick the photobucket box under upload I get the same error from them."

What error do you see?

The attachment will reference the remote file if you don't have a quota. You can confirm this by taking a look in the attachments table - you should see the a_url field as remote.

Lhasadreams

2013-09-22 11:02

reporter   ~0001758

I attached a pic of the error.

Ah ok so I have a quota - does that mean that anyone with a quota cannot syndicate out then ? It did syndicate out for me, I could see the images on Photobucket but when I look at the post thread it was not the linked image but an attachment.
I would want to be able to choose the option as to whether I syndicate or not for users that have a quota please.

Chris Graham

2013-09-22 11:10

administrator   ~0001759

Last edited: 2013-09-22 11:11

View 2 revisions

Oh, it will syndicate, it just won't delete the local file (replace with a remote link) if you have a quota. I could make it auto-delete for all if you prefer.

I think that error you saw happens if oAuth is not confirmed initially. It would be good to see if other users are getting it and when.
Because Photobucket doesn't do the callback style of oAuth, we have to store a temporary authorisation request, rather than only storing the final authorisation only once it has been confirmed.

Lhasadreams

2013-09-22 11:32

reporter   ~0001760

I would prefer to have the option to choose if you have a quota.

It worked fine for me once I had logged into photobucket in another window.

Will get a few people to try it out and let you know.

Cheers
Ade

Chris Graham

2013-09-22 13:11

administrator   ~0001761

Okay, "Reference remotely (delete locally)" option added.

Lhasadreams

2013-09-22 17:22

reporter   ~0001762

Thanks for that.

Just tried submitting on my iPad with a remote reference and got a bail out:


Fatal error: Call to undefined function sort_maps_by() in /home/vwgolfm/public_html/sources/upload_syndication.php on line 236
Critical error – bailing out

This is an error that has been elevated to critical error status because it occurred during the primary error mechanism reporting system itself (possibly due to it occuring within the standard output framework). It may be masking a secondary error that occurred before this, but was never output - if so, it is likely strongly related to this one, thus fixing this will fix the other.
PHP NOTICE [8] Undefined variable: param in sources/failure.php on line 945 (version: 9.0.5, PHP version: 5.3.20, URL: /forum/index.php?page=topics&type=_edit_post)
Details here are intended only for the website/system-administrator, not for regular website users.
» If you are a regular website user, please let the website staff deal with this problem.

Depending on the error, and only if the website installation finished, you may need to edit the installation options (the info.php file).

ocProducts maintains full documentation for all procedures and tools. These may be found on the Composr website. If you are unable to easily solve this problem, we may be contacted from our website and can help resolve it for you.

Composr is a CMS for building websites, developed by ocProducts.

Lhasadreams

2013-09-22 17:27

reporter   ~0001763

If I uncheck reference remotely it does not bail out.

Chris Graham

2013-09-22 18:44

administrator   ~0001764

Ah, sorry about that (back-porting error) - fixed.

Lhasadreams

2013-09-22 19:22

reporter   ~0001765

Hey no worries - works now.

I have just tried to use it with account that has zero attachment quota and nothing gets uploaded to photobucket and there is a quota error returned:

"You would be over your daily upload quota of 0 MB (you are currently using 0.00 MB)."

http://vwgolfmk1.org.uk/forum/index.php?page=topicview&id=general-chat_3%2Ftest_24&redirected=1#post_1345370

Does there need to be an artificial limit to allow say up to a certain photo size to be uploaded ?


Also I found that the only way to get the integration to setup is to first login to photobucket in the same browser. Then try and add an attachment, then you just get asked to verify that the app is allowed to do that.

Lhasadreams

2013-09-22 19:28

reporter   ~0001766

Also is it possible to do what you did for the pop up attachment property window for the iphone to work the same on a tablet as well please ?

Cheers
Ade

Chris Graham

2013-09-22 23:19

administrator   ~0001769

"I have just tried to use it with account that has zero attachment quota and nothing gets uploaded to photobucket and there is a quota error returned:"

Did you authorise that account? The quota check is bypassed if it knows it can syndicate then delete locally.

The authorisation is stored against account (an oAuth access token), not via a cookie. You can authorise as many accounts as you like against a single Photobucket account, each would get a different token.

I think there may be a timeout issue. If you don't finish making your post within a certain time, the access token request may time out before it is converted into an actual access token. It may therefore help to do the checkbox first (before adding an attachment or writing a post), approve oauth, refresh (rather than just closing the overlay), and then continue. That only needs doing once, then the token is saved forever.

--

I have just made overlays scroll with the page on iPads as per iPhones (due to the lack of easy independent frame scrolling on iOS devices). I thought I'd actually done this for you before, as it was done in Composr quite a while back and I thought due to work on your site.

Lhasadreams

2013-09-23 11:58

reporter   ~0001770

Hi Chris,

It does seem to matter which way I spin it, I cannot get it to work for a user with no quota.

The test case is:
cms user = hisboss (wifes account)

She has a valid photobucket account with a username of flashred - she can upload photos to this account.

I authorised the account using the same method, ie logged separately in to Photobucket as flashred and then ticked the box on the attachment area, it threw the authorisation dialogue up.

How do I de authorise an account from Photobucket ?

Thanks for the ipad fix

Cheers
Ade

Lhasadreams

2013-09-23 18:59

reporter   ~0001773

Hi Chris,

Just got back from Bristol and I thought that I would try again.

I don't know if you have tweaked anything but the error is now a different one:

"An error has occurred - there are too many attachments in your post"

It would be useful to know how to disconnect an account from photobucket as well, so that I can understand which photobucket account the Composr one is connected to.

Cheers
Ade

Lhasadreams

2013-09-23 19:55

reporter   ~0001774

Hi Chris,

Doing some more tests !

If I turn on the "Exceed quota/file limit" for the newbies (which hisboss is a member) group then the image uploads to photo bucket and gets stored as an attachment in cop - so the integration is working to photobucket.

It appears that your new code is not respecting the zero attachment size entitlement and is blocking the upload due to the quota being exceeded.

Can you take another look at this please.

Cheers
Ade

Chris Graham

2013-09-24 01:08

administrator   ~0001778

Hi,

Sorry about that, I can see the issue now. It is probably a backporting mistake.

Regarding deauthorisation. There's no method I'm aware of. With Facebook, they provide privacy controls to deauthorise sites. Maybe photobucket has the same. There's no mechanism built into Composr for it, but I can tell you the keys are stored into the long_values table, along with some other photobucket data. Photobucket things can be safely purged from there.

Chris Graham

2013-09-24 01:19

administrator   ~0001779

Fixed now :). It was indeed a backporting bug related to the quota bypass.

Btw, to confirm to yourself something is hosted on Photobucket, you can open an attachment's view link into a new window. You'll see the browser URL redirects from attachment.php to a remotely hosted URL (which is the normally attachment.php behaviour for when an attachment is remote).

Lhasadreams

2013-09-24 22:01

reporter   ~0001786

Thanks for all the info Chris.
I have tested it all now and launched the feature on the masses.

One thing that appears to of regressed though. If a user has a quota and the reference remotely delete locally box is ticked, it does not seem to have any effect now. The photo is uploaded but still referenced locally.

For example I uploaded to this thread
http://vwgolfmk1.org.uk/forum/index.php?page=topicview&id=chat%2Fgeneral-chat_3%2Fnew-forum-feature&redirected=1#post_1346117
With the box ticked.


On another note, is this new feature packaged so that Kenno could have it on his bulldog owners site as well - would there be a cost implication to him?

Many thanks
Ade

Lhasadreams

2013-09-25 07:35

reporter   ~0001788

Sorry Chris, this has not regressed - it was just the way I was checking the link.

Chris Graham

2013-09-25 10:31

administrator   ~0001789

"On another note, is this new feature packaged so that Kenno could have it on his bulldog owners site as well - would there be a cost implication to him?"

I back-ported it direct to your site, first uploading new files, then all at once editing all the existing files that needed new code. There's no problem sharing it, but if I was to repackage it for a stock v9 I'd need to charge another hour.

Lhasadreams

2013-10-14 20:45

reporter   ~0001833

Hi Chris,

I have just tried to upload more than one image in the same post and it throws an error

"File storage directly on The Mk1 Golf Owners Club is not currently available. You must select at least one valid syndication target. "

Was it designed to allow multiple images to upload ?

Cheers
Ade

Chris Graham

2013-10-15 12:38

administrator   ~0001834

Whoops, it should work now. The syndication options weren't getting added to the dynamically added extra upload field(s).

Lhasadreams

2013-10-17 20:59

reporter   ~0001837

Hi Chris,

I would like one more usability feature please - happy to pay for it mate.

Clicking upload on an attachment causes another window to pop up - there is no reason to have this extra annoyance for most users. All they would want is for the full size image to be embedded directly.

So can it be modded so that if the image is ticked to be syndicated to photo bucket then the second pop up does not show and it simply gets rendered as not a thumbnail and enbedded directly ?

Cheers
Ade

Chris Graham

2013-10-18 15:42

administrator   ~0001838

Okay, I've generalised as 0001428. I didn't tie this directly to the upload syndication, as really this is just a general tuning of attachments, correct?

Lhasadreams

2013-10-21 07:15

reporter   ~0001839

Hi Chris,
I have sponsored the generalised version.
Cheers
Ade

Lhasadreams

2013-10-31 20:07

reporter   ~0001859

Hi,

The option to load more than one image at a time has disappeared.

It lets you do one no problem, but then it use to add a second box - that has now gone away - any idea ?

Cheers
Ade

Chris Graham

2013-10-31 20:41

administrator   ~0001861

Ah - sorry, fixed.

Lhasadreams

2013-11-18 18:46

reporter   ~0001888

Hi,
I am getting several users reporting that they cannot upload images.
See this thread:
http://vwgolfmk1.org.uk/forum/index.php?page=topicview&id=meets-events-and%2Fwas-it-you_2%2Fimmaculate-white-cabby&kfs84=30

What cannot work out is whether this is a photobucket problem or an integration problem, can someone take a look please.
Cheers
Ade

Lhasadreams

2013-11-18 20:13

reporter   ~0001889

Hi,
So I have investigated a little further.
I also get an error if I su as the same user that cannot upload - the error is different and talks about there are already too many attachments uploaded.

The users that are complaining are in the "Newbie" user group - this lead me to look at the number of attachments that they are allowed to upload, this is set as zero, so i changed it to 10 and they can now upload. I tried it both as su and the user tried as themselves - so all good.
However the other Primary Usergroups all have the upload number set to zero as well - I have changed all of them to 10 now though.
I wonder if something else is over riding the quota for the other groups ?

Cheers
Ade

Chris Graham

2013-11-26 11:28

administrator   ~0001890

Sorry for the delay, v10 development messed up my work schedule recently.

We will make a usability change for v10 where no attachment upload is offered if the attachment number is zero. i.e. we'll give that case special handling in the UI.

I don't think I see a bug here, but rather Composr is not communicating the limits well.

Lhasadreams

2013-12-21 11:55

reporter   ~0001928

Hi Chris,

Some users are still getting this error. Not always newbies either
Take this post for example
http://vwgolfmk1.org.uk/forum/index.php?page=topicview&id=chat%2Fgeneral-chat_3%2Fwhat-are-these-wheels_10

Not sure where to look - can you help
Cheers
Ade

Chris Graham

2014-01-04 17:04

administrator   ~0001985

I am currently investigating.

I was able to get photobucket working fine. However, if I ignored the photobucket activation, I did get a zero quota error. I'll see if I can make that error more explicit, perhaps reference photobucket.

Chris Graham

2014-01-04 17:07

administrator  

Chris Graham

2014-01-04 17:07

administrator  

Lhasadreams

2014-01-04 17:27

reporter   ~0001986

Hi Chris,

There may be a clue there.

When I ask posters to post again it seems to work ok for them - so maybe it is just a time delay between Photobucket setting up and allowing uploads ?

The majority of the moaning stopped once I lifted the quota to 10, so I think that this is an edge case.

Cheers
Ade

Lhasadreams

2014-01-04 17:32

reporter   ~0001987

Just spotted another user experiencing the same

http://vwgolfmk1.org.uk/forum/index.php?page=topicview&id=newbies_2%2Ftest

Chris Graham

2014-01-04 17:33

administrator  

Chris Graham

2014-01-04 17:38

administrator   ~0001988

"When I ask posters to post again it seems to work ok for them - so maybe it is just a time delay between Photobucket setting up and allowing uploads ?"

I suspect they were just reading more carefully that the Photobucket checkbox had "required" next to it, or realising they had to click through to provide auth rather than just closing the overlay right away. I don't think there's a delay in the process because the auth is approving a key already known to Composr when the auth happens. The key is generated, then the UI is to approve that key.

"Just spotted another user experiencing the same"

This was me ;-). I was testing as the same user you reported above.

I have attached a screenshot of how the zero quota message now looks - as you can see, it clearly explains Photobucket.

Lhasadreams

2014-01-04 17:39

reporter   ~0001989

Doh - that was you !!!

Chris Graham

2016-12-08 17:21

administrator   ~0004627

Closing this, any further ideas and discussion can be in 0002020 which covers extending to other social media channels.

Issue History

Date Modified Username Field Change
2016-12-02 17:22 Chris Graham Relationship added related to 0002962
2016-12-08 16:08 Chris Graham Relationship deleted child of 0002020
2016-12-08 16:10 Chris Graham Tag Attached: Type: External social media integration
2016-12-08 17:21 Chris Graham Note Added: 0004627
2016-12-08 17:21 Chris Graham Status non-assigned => closed
2016-12-08 17:21 Chris Graham Assigned To => Chris Graham
2016-12-08 17:21 Chris Graham Resolution open => fixed
2017-03-21 21:59 Chris Graham Relationship added related to 0003147